import 'dart:async';

import 'package:flutter/widgets.dart';

import 'rx_stream.dart';

abstract class RxInterface<T> {
  static RxInterface proxy;

  bool get canUpdate;

  StreamSubscription<T> listen(
    void Function(T event) onData, {
    Function onError,
    void Function() onDone,
    bool cancelOnError,
  });

  void addListener(Key key, RxStream<T> rxStream);

  void close();
}
