import '../core/rx_impl.dart';

class RxString extends RxImpl<String> implements Comparable<String>, Pattern {
  RxString([String initial]) : super(initial);

  String operator +(String val) => value + val;

  @override
  int compareTo(String other) => value.compareTo(other);

  bool endsWith(String other) => value.endsWith(other);

  bool startsWith(Pattern pattern, [int index = 0]) => value.startsWith(pattern, index);

  int indexOf(Pattern pattern, [int start = 0]) => value.indexOf(pattern, start);

  int lastIndexOf(Pattern pattern, [int start]) => value.lastIndexOf(pattern, start);

  bool get isEmpty => value.isEmpty;

  bool get isNotEmpty => !isEmpty;

  String substring(int startIndex, [int endIndex]) => value.substring(startIndex, endIndex);

  String trim() => value.trim();

  String trimLeft() => value.trimLeft();

  String trimRight() => value.trimRight();

  String padLeft(int width, [String padding = ' ']) => value.padLeft(width, padding);

  String padRight(int width, [String padding = ' ']) => value.padRight(width, padding);

  bool contains(Pattern other, [int startIndex = 0]) => value.contains(other, startIndex);

  String replaceAll(Pattern from, String replace) => value.replaceAll(from, replace);

  List<String> split(Pattern pattern) => value.split(pattern);

  List<int> get codeUnits => value.codeUnits;

  Runes get runes => value.runes;

  String toLowerCase() => value.toLowerCase();

  String toUpperCase() => value.toUpperCase();

  @override
  Iterable<Match> allMatches(String string, [int start = 0]) => value.allMatches(string, start);

  @override
  Match matchAsPrefix(String string, [int start = 0]) => value.matchAsPrefix(string, start);
}

extension RxStringExt on String {
  RxString get obs => RxString(this);
}
